# VMware vCenter

## Prerequisites: <a href="#prerequisites" id="prerequisites"></a>

VMware vCenter is a management software to manage and monitor VMware vSphere virtual infrastructure environments. CloudFabrix's RDA supports integrating with VMware vCenter through it's API interface to collect the inventory on-demand or on schedule basis.

* Supported VMware vCenter versions are 5.5, 6.x and above.
* User account with 'read-only' access permissions for all of the Virtual Infrastructure objects (Datacenter, Cluster, ESXi Host, Virtual Machine, Datastore, Resource Pool etc)

## Creating an user account with read-only permissions for API access: <a href="#enabling-api-access-on-appdynamics-saas-controller" id="enabling-api-access-on-appdynamics-saas-controller"></a>

**Step 1**: Login to VMware vCenter web client  using a supported web browser with an user account which has enough privileges to create a new account and set the read-only permissions for all Virtual Infrastructure objects.

![](/files/-MXGQOtj0oSV4CjdCEuW)

**Step 2**: Click on '**Menu**' and click on '**Administration**'.

![](/files/-MXGR9zzhk638idWE3Po)

**Step 3**: Click on '**Users and Groups**'  on left menu, click on '**Users**', select domain as '**vsphere.local**' and click on ' **Add User**' button.

![](/files/-MXGT3fxtGYnl--h5DIm)

**Step 4**: Enter user account details as shown below and click on **Add** button.

![](/files/-MXGUG1txcM-pHcN0C9I)

**Step 5**: Click on '**Menu**' and click on '**Home**' button.

![](/files/-MXGUpq1SP0AhJnz6cVC)

**Step 6**: Click on '**vSphere Cluster**' icon and click on '**vCenter**' object on left and click on '**Permissions**' tab and click on '**+**' button.

![](/files/-MXGVv6eO0V1wEUo3ZWq)

![](/files/-MXGWcMs3IetqxitGsg0)

**Step 7**: Under '**vsphere.local**' domain, enter 'readonly' user account which was created above and select the '**Role**' as '**Read-only**' and click on '**OK**'.

![](/files/-MXGXETrmBS84J7aX1Tn)

## Adding VMware vCenter as Datasource/Extension in 'RDA': <a href="#adding-appdynamics-as-datasource" id="adding-appdynamics-as-datasource"></a>

VMware vCenter or any other datasource/extension's configuration is configured in RDA's user interface.  Login into RDA's user interface using a browser.

**https\://\<rda-ip-address>:9998**

Under '**Notebook**', click on '**CFXDX Python 3**' box

![](/files/-McvJao2W2zwuMV05Ek3)

In the '**Notebook**' command box, type **`botadmin()`** and **`alt (or option) + Enter`** to open datasource administration menu.

Click on '**Add**' menu and under **Type** drop down, select **`vmware-vcenter`**

![](/files/-McvLpTSfHkATU0kDn3T)

* **type**: Datasource/Extension type. In this context, it is '**vmware-vcenter**'
* **name**: Datasource/Extension label which should be unique within the RDA
* **Hostname:** VMware vCenter's IP Address or DNS name
* **Username**: User account that was created with 'read-only' permissions
* **Password**: User account's password

Click on '**Check Connectivity**' to verify the network access and credentials validity. Once it is validated, click on '**Add**' button to add the vCenter as datasource.

## VMware vCenter data exploration in '**RDA**': <a href="#adding-appdynamics-as-datasource" id="adding-appdynamics-as-datasource"></a>

Once VMware vCenter integration details are configured in the RDA's as datasource, it will be ready to connect to VMware vCenter instance and explore the data for the analysis.

* Run the below command to check and verify network access to VMware vCenter instance using the read-only user account's credentials entered within the RDA's datasource configuration.  The '**status**' output should show as '**OK**'

```
check vcenter
```

![](/files/-MXG_DlXFqgRHNDfr4Xy)

```
> tags vcenter

or

> bots vcenter
```

* Run the below command within the **RDA CLI** to list the available '**Tags**' or '**Bots**' for VMware vCenter extension. In this example, the VMware vCenter extension is labelled as '**vcenter**' which will be referenced within each applicable tag name.

{% hint style="info" %}
Each listed '**tag**' starts with a special character (i.e. **\*** or **#** or **@**) and each hints about **tag's** filtering capability. For more information abut them, please refer to "[**RDA Terminology**](https://docs.cloudfabrix.io/rda/introduction-to-rda/rda-terminology)"
{% endhint %}

![](/files/-MXGZcI4Z4ArW4Uv-hU9)

Tags:

* **vms**: Collects VMware virtual machine inventory
* **hosts**: Collects VMware ESXi Hosts and Cluster inventory
* **vswitches**: Collects VMware Standard & Distributed vSwitch inventory
* **datastores**: Collects VMware datastore storage inventory

Run the below commands to query and collect the VMware virtual machine inventory data.

```
> bot *vcenter:vms
```

```
*vcenter:vms> data
```

Run the below commands to query and collect the ESXi Hosts and Cluster inventory data.

```
> bot *vcenter:hosts
```

```
*vcenter:hosts> data
```

Run the below commands to query and collect the ESXi Standard & Distributed vSwitch inventory data.

```
bot *vcenter:vswitches
```

```
*vcenter:vswitches> data
```

Run the below commands to query and collect the ESXi datastore inventory data.

```
bot *vcenter:datastores
```

```
*vcenter:datastores> data
```

## VMWare vCenter exploration in '**RDA**': <a href="#adding-appdynamics-as-datasource" id="adding-appdynamics-as-datasource"></a>

Once VMWare vCenter integration details are configured in RDA as a datasource, it will be ready to connect to targe Nagios and explore the data for the analysis.

For the details on vCenter data collection bots, refer [**CloudFabrix RDA Bot documentation.**](https://bot-docs.cloudfabrix.io/Bots/vmware-vcenter/)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.cloudfabrix.io/rda/cfxdx-datasource-integrations/vmware-vcenter.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
